<?php
require_once ('../include/inc_mysql.php');

session_start();

$warning = NULL;

if (file_exists('../conf.php')) {
	$title = 'Erreur...';
	$html = 'Un fichier de configuration existe dj. Veuillez supprimer le fichier \'conf.php\' avant de continuer.<br />';
	include('include/inc_header.php');
	include('include/inc_text_zone.php');
	include('include/inc_footer.php');
	exit();
}

if (isset($_GET['step']))
	$step = $_GET['step'];
else
	$step = 0;

switch($step) {
case 1:
	$db_selected = NULL;
	$error = false;
	$host = $_POST['host'];
	$username = $_POST['username'];
	$pw = $_POST['pw'];
	$db = $_POST['db'];

	if ($host && $username && $pw && $db) {
		// Let's see if we can connect to the database.
		if($link = @mysql_connect($host, $username, $pw)) {
			// Let's see if we can select the database.
			if ($db_selected = @mysql_select_db($db, $link)) {
				// Save database information
				$_SESSION['cgdl_host'] = $host;
				$_SESSION['cgdl_username'] = $username;
				$_SESSION['cgdl_pass'] = $pw;
				$_SESSION['cgdl_db'] = $db;

				$result = mysql_list_tables($db);

				$duplicate_db = false;
				while ($row = mysql_fetch_row($result)) {
					if($row[0]=='cgd_access' || $row[0]=='cgd_users')
						$duplicate_db = true;
				}

				if ($duplicate_db) {
					// Already installed...
					$warning = 'Coolguys Downloader est dj install dans cette base de donnes. Vous pouvez choisir de l\'installer dans une autre base, de vider manuellement cette base (via phpMyAdmin par exemple), ou de <a href="setup_fr.php?step=2">continuer</a> sans apporter de modification  la base.';
					$error = true;
				} else {
					// Check to see if user can write to database.
					$query = "CREATE TABLE `cgd_access` (
					`id` int(11) unsigned NOT NULL auto_increment,
					`start_date` int(11) unsigned NOT NULL default '0',
					`end_date` int(11) unsigned NOT NULL default '0',
					`uses_left` smallint(4) NOT NULL default '0',
					`hash` varchar(32) default NULL,
					`dir` text,
					`ip` varchar(16) default '0.0.0.0',
					`is_admin` tinyint(1) unsigned NOT NULL default '0',
					`can_create_account` tinyint(1) unsigned NOT NULL default '0',
					`user_account` varchar(20) default NULL,
					UNIQUE KEY `id` (`id`)
					) TYPE=MyISAM AUTO_INCREMENT=2";
					if(mysql_query($query)) {
						// Insert a setup key into database.
						$query = "INSERT INTO `cgd_access` VALUES (1, 0, 4294967295, -1, 'setup', '', '0.0.0.0', 1, 1, null)";
						if(mysql_query($query)) {
							$query = "CREATE TABLE `cgd_users` (
							`id` int(11) unsigned NOT NULL auto_increment,
							`name` varchar(20) default NULL,
							`passwd` varchar(32) default NULL,
							`email` varchar(80) default NULL,
							`dir` text,
							`is_admin` tinyint(1) unsigned NOT NULL default '0',
							UNIQUE KEY `id` (`id`)
							) TYPE=MyISAM AUTO_INCREMENT=1";
							$result = mysql_query($query);
							// All done.
						} else {
							$warning = 'Impossible d\'insrer les informations dans la table. Vrifiez que vous disposez des droits adquats pour raliser cette opration.';
							$error = true;
						}
					} else {
						$warning = 'Impossible de crer la table. Vrifiez que vous disposez des droits adquats pour raliser cette opration.';
						$error = true;
					}
				}
			} else {
				$warning = 'Impossible d\'accder  la base \'' . $db . '\'. Si elle n\'existe pas, vous devez la crer manuellement.';
				$error = true;
			}
		} else {
			$warning = 'Une erreur s\'est produite lors de la connexion au serveur MySQL.<br />Vrifiez que les informations \'Hte\', \'Nom d\'utilisateur\' et \'Mot de passe\' sont correctes.';
			$error = true;
		}
	} else {
		$warning = 'Veuillez remplir correctement tous les champs.';
		$error = true;
	}

	// We're finished with mysql
	if ($db_selected)
		mysql_close();

	if ($error) {
		include('include/inc_header.php');
		include('include/inc_db_setup_fr.php');
		include('include/inc_footer.php');
		exit();
	}

	$title = 'Step 1: database setup';
	$html = 'La configuration de la base MySQL s\'est droule parfaitement. Poursuivez maintenant  <a href="setup_fr.php?step=2">l\'tape 2</a>.';
	include('include/inc_header.php');
	include('include/inc_text_zone.php');
	include('include/inc_footer.php');
	break;

case 2:
	$uploaddir = dirname(dirname($_SERVER['SCRIPT_FILENAME'])) . '/default_folder/';
	$lang = 'fr_FR';
	$chmod = '0777';
	include('include/inc_header.php');
	include('include/inc_gen_settings_fr.php');
	include('include/inc_footer.php');
	break;

case 3:
	$uploaddir = $_POST['folder'];
	$lang = $_POST['lang'];
	$chmod = $_POST['chmod'];
	if ($uploaddir && $lang && $chmod) {
		$title = 'Installation termine !';

		if (!$handle = @fopen('../conf.php', 'a')) {
			$html = 'L\'assistant d\'installation n\'a pas pu enregistrer le fichier de configuration. Pour complter cette tape, il vous suffira de copier le texte suivant dans un nouveau fichier \'conf.php\' et de l\'uploader par FTP.<br /><br />';
			$html .= '&lt;?php<br />$db_access[\'host\'] = \'' . $_SESSION['cgdl_host'] . '\';<br />$db_access[\'username\'] = \'' . $_SESSION['cgdl_username'] . '\';<br />$db_access[\'password\'] = \'' . $_SESSION['cgdl_pass'] . '\';<br />$db_access[\'database\'] = \'' . $_SESSION['cgdl_db'] . '\';<br /><br />$UploadDir = \'' . $uploaddir . '\';<br />$SetDisplayLang = \'' . $lang . '\';<br />$SetChmod = ' . $chmod . ';<br />?&gt;<br /><br />';
			$html .= 'Ensuite, <a href="../?key=setup">cliquez ici</a> pour crer un compte administrateur.';
		} else {
			$html = 'L\'installation est finie. Le fichier de configuration \'conf.php\' a t enregistr et peut s\'diter manuellement si cela s\'avre ncessaire.<br /><br /><a href="../?key=setup">Cliquez ici</a> pour crer un compte administrateur..';
			$filecontent = "<?php\n\$db_access['host'] = '" . $_SESSION['cgdl_host'] . "';\n\$db_access['username'] = '" . $_SESSION['cgdl_username'] . "';\n\$db_access['password'] = '" . $_SESSION['cgdl_pass'] . "';\n\$db_access['database'] = '" . $_SESSION['cgdl_db'] . "';\n\n\$UploadDir = '" . $uploaddir . "';\n\$SetDisplayLang = '" . $lang . "';\n\$SetChmod = " . $chmod . ";\n?>";
			fwrite($handle, $filecontent);

			// Set permissions otherwise it may not be possible to remove file via ftp
			chmod('../conf.php', 0777);

			fclose($handle);
		}

		include('include/inc_header.php');
		include('include/inc_text_zone.php');
		include('include/inc_footer.php');
	} else {
		$warning = 'Veuillez remplir correctement tous les champs.';
		include('include/inc_header.php');
		include('include/inc_gen_settings_fr.php');
		include('include/inc_footer.php');
	}
	break;

default:
	$host = 'localhost';
	$username = 'root';
	$db = 'cg_downloader';
	include('include/inc_header.php');
	include('include/inc_db_setup_fr.php');
	include('include/inc_footer.php');
	break;
}
?>